<template>
  <section key="aparments">
    <!-- Filters -->
    <app-bar-filter @filter="showFilters = !showFilters && $event" />
    <!-- Page -->
    <v-row no-gutters>
      <v-col v-show="showList || isDesktop" cols="12" md="5">
        <v-card flat>
          <app-properties :is-moving="isMoving" />
          <app-filters v-model="showFilters" />
        </v-card>
      </v-col>
      <v-col v-show="!showList || isDesktop" md="7">
        <app-map style="position: sticky; top: 96px" :visible="!showList || isDesktop" @is-moving="isMoving = $event" />
      </v-col>
    </v-row>
    <v-bottom-navigation class="hidden-md-and-up" app fixed horizontal grow>
      <v-btn>Filter <v-icon>{{ mdiFilterMenu }}</v-icon></v-btn>
      <v-btn @click="showList = !showList">
        {{ showList ? 'Map' : 'List' }}
        <v-icon>
          {{ showList ? mdiMap : mdiFormatListBulletedSquare }}
        </v-icon>
      </v-btn>
    </v-bottom-navigation>
  </section>
</template>

<script lang="ts">
import { mdiFilterMenu, mdiMap, mdiFormatListBulletedSquare } from '@mdi/js'
import { defineComponent, ref, onBeforeUnmount, onMounted, watch } from '@vue/composition-api'
import AppProperties from '@/components/AppProperties.vue'
import AppBarFilter from '@/components/AppBarFilter.vue'
import AppFilters from '@/components/AppFilters.vue'
import AppMap from '@/components/AppMap.vue'

import { useQuery } from '@/hooks'

interface City {
  src: string
  name: string
  type: string[]
  fullName: string
  viewport: [number, number][]
}

export default defineComponent({
  name: 'Rents',
  components: { AppProperties, AppMap, AppBarFilter, AppFilters },
  setup (_, context) {
    const page = +context.root.$route.query.page ?? 1
    context.root.$store.commit('properties/setPage', page)
    context.root.$store.commit('properties/resetItems')
    const { resetFilters, filters } = useQuery(context)
    const showList = ref(true)
    const isDesktop = ref(true)

    onMounted(() => {
      isDesktop.value = context.root.$vuetify.breakpoint?.mdAndUp ?? true
    })
    onBeforeUnmount(resetFilters)
    watch(() => JSON.stringify(filters.value), async () => {
      if (!Object.keys(filters.value).length) { return }
      await context.root.$store.dispatch('properties/fetchItems', filters.value)
    })
    return {
      isDesktop,
      showFilters: ref(false),
      isMoving: ref(false),
      mdiFilterMenu,
      mdiMap,
      showList,
      mdiFormatListBulletedSquare
    }
  }
})

</script>

<style>
.filter-overlay .v-overlay__content {
  width: 100%;
  justify-content: center;
  display: flex;
  position: sticky;
  top: 110px
}
</style>
